
echo "\n\nDownload, fix, and run gsinstall"
wget https://aptrepo.srv.cs.cmu.edu/gsinstall.sh
#modify gsinstall to not require intervention
sed -i -e 's/apt-get install /apt-get -y install /g' gsinstall.sh
sed -i -e 's/apt-add-repository /apt-add-repository -y /g' gsinstall.sh

/bin/sh gsinstall.sh



apt-get -y install tcsh zsh iptables 


########### looks like I dont need this at all
########### 
#printf "\n\nServer Krb ticket grabbing\n"

#apt-get install cmucs-keyme

# shouldn't need this with debconf
# cmucs-keyme -P "$pin"

#apt-get -y install libpam-heimdal ldap-utils



printf "\n\ncheck for nvidia and install drivers\n"

if [[ $(lshw -C display | grep vendor) =~ NVIDIA ]]; then
  apt-get -y install nvidia-driver-550
  
  #originally asked about cuda, but might as well just get it
#  read -p "Install cuda 12.6? " -n 1 -r ; echo
#  if [[ $REPLY =~ ^[Yy]$ ]]
#  then
    wget https://developer.download.nvidia.com/compute/cuda/repos/ubuntu2404/x86_64/cuda-keyring_1.1-1_all.deb
    dpkg -i cuda-keyring_1.1-1_all.deb
    apt-get update
    apt-get -y install cuda-toolkit-12-6 cuda-toolkit-12-6
#  fi

fi

# TODO do we want to put the cuda keyring on by default and not install anything?


##### tibs fixes for xinetd 
echo "terad		1967/tcp			# TiBS client" >> /etc/services
mkdir /etc/xinetd.d
cat > /etc/xinetd.d/terad <<EOF
service terad
{
    id          = terad
    port        = 1967
    socket_type   = stream
    protocol    = tcp
    user        = root
    wait        = no
    server      = /usr/sbin/terad
}
EOF


# all tibs servers
iptables -A INPUT -s 128.2.192.33/32  -p tcp --dport 1967 -j ACCEPT
iptables -A INPUT -s 128.2.201.38/32  -p tcp --dport 1967 -j ACCEPT
iptables -A INPUT -s 128.2.201.220/32 -p tcp --dport 1967 -j ACCEPT
iptables -A INPUT -s 128.2.201.193/32 -p tcp --dport 1967 -j ACCEPT

# doesnt work
# nft add rule filter input ip daddr 128.2.192.33 dport 1967 accept 
# nft add rule filter input ip daddr 128.2.201.38 dport 1967 accept 
# nft add rule filter input ip daddr 128.2.201.220 dport 1967 accept 
# nft add rule filter input ip daddr 128.2.201.193 dport 1967 accept 


apt-get -y upgrade

#reboot
printf "\n\n\n"
printf "now reboot\n"

